
<template>
  <div v-loading="loading">
    <div class="select-container">
      <el-form :inline="true">
        <el-form-item label="电池堆">
          <el-select v-model="pcs" placeholder="请选择" :loading="loading" loading-text="正在加载数据">
            <el-option :label="item.deviceName" :value="item.id" v-for="(item,index) in pcsOptions" :key="index+'pcsListOptions'"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="时间选择">
          <el-date-picker
            v-model="dateRange"
            type="daterange"
            range-separator="至"
            start-placeholder="开始时间"
            :picker-options="pickerOptions"
            :default-value="defaultDateRange"
            end-placeholder="结束时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="onSearch" native-type="button">搜索</el-button>
        </el-form-item>
        <el-form-item>
          <el-button @click="onReset" native-type="button">重置</el-button>
        </el-form-item>
      </el-form>
    </div>
    <div style="margin:30px 0;">
      <!--        二个选择按钮-->
      <el-row style="">
        <el-col :xs="24" :sm="24" :lg="24">
          <el-button-group class="ems-btns-group">
            <el-button v-for="(item,index) in btnList" :key="index+'dcdqxBtns'" :class="{'activeBtn' : activeBtn === item.id}" @click="changeDataType(item.id)">{{item.name}}</el-button>
          </el-button-group>
        </el-col>
      </el-row>
      <!--echart-->
      <div id="dcdEchart" style="height:360px;"></div>
    </div>
  </div>
</template>


<script>
import * as echarts from 'echarts'
import resize from "@/mixins/ems/resize";
import getQuerySiteId from "@/mixins/ems/getQuerySiteId";
import { getStackData, getStackNameList} from '@/api/ems/dzjk'
import {formatDate} from "@/filters/ems";
export default {
  name:'DzjkTjbbDcdqx',
  mixins: [resize,getQuerySiteId],
  data() {
    return {
      pickerOptions:{
        disabledDate(time) {
          return time.getTime() > Date.now();
        },
      },
      defaultDateRange:[],//默认展示的时间
      dateRange:[],
      loading:false,
      pcs:'',
      pcsOptions: [],
      activeBtn:'1',
      btnList:[
        {name:'堆平均维度',id:'1',attr:['temp'],source:[['日期','有功功率']]},
        {name:'堆电压',id:'2',attr:['voltage'],source:[['日期','堆电压']]},
        {name:'堆电流',id:'3',attr:['current'],source:[['日期','堆电流']]},
        {name:'堆soc',id:'4',attr:['soc'],source:[['日期','堆soc']]},
      ],
    }
  },
  methods: {
    changeDataType(id){
      if(id !== this.activeBtn){
        this.activeBtn=id;
        this.getData()
      }
    },
    // 搜索
    onSearch(){
      this.getData()
    },
    // 重置
    onReset(){
      // this.pcs = this.pcsOptions.length > 0 ?this.pcsOptions[0].id : ''
      this.dateRange=''
      this.getData()
    },
    getPcsList(){
      return getStackNameList(this.siteId).then(response => {
        const data = JSON.parse(JSON.stringify(response?.data || []))
        this.pcsOptions = data
        this.pcs = data.length>0?data[0].id:'';
      })
    },
    getData(){
      const {siteId,pcs,activeBtn}=this;
      const [start='',end='']=(this.dateRange || [])
      if(!pcs) return
      //接口调用完成之后 设置图表、结束loading
      this.loading=true;
       getStackData({siteId,deviceId:pcs,startTime:formatDate(start),endTime:formatDate(end),dataType:activeBtn}).then(response => {
        this.setOption(response?.data || [])
      }).finally(()=>{this.loading=false;})

    },
    setOption(data) {
      const ele = this.btnList.find((item)=>{return item.id === this.activeBtn})
      const source = JSON.parse(JSON.stringify(ele.source))
      const length = ele.attr.length
      const series = []
      data.forEach((item)=>{
        const arr = ele.attr.map(key=>item[key])
        source.push([item.statisDate,...arr])
      })
      ele.attr.forEach((item)=>{
        series.push({
          name:length>1?item:ele.name,
          type:ele.type || 'scatter'
        })
      })
      this.chart.setOption({
        color:['#FFBD00','#3C81FF'],
        grid: {
          containLabel: true
        },
        legend: {
          left: 'center',
          bottom: '15',
        },
        tooltip: {
          trigger: 'axis',
          axisPointer: { // 坐标轴指示器，坐标轴触发有效
            type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
          }
        },
        textStyle:{
          color:"#333333",
        },
        xAxis: {
          type: 'category',
        },
        yAxis: {
          type: 'value',
        },
        dataset: {source},
        series
      },true)
    },
    initChart() {
      this.chart = echarts.init(document.querySelector('#dcdEchart'));
    },
    init(){
      this.loading = true
      this.pcs=''
      this.pcsOptions=[]
      this.initChart()
      this.getPcsList().then(()=>{
        if(this.pcs){
          this.onReset()
        }else{
          this.loading = false
        }
      })
    }
  },
  mounted(){
    const now = new Date();
    const lastMonth = new Date(now.getFullYear(), now.getMonth() - 1, 1);
    this.defaultDateRange = [lastMonth, now];
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
}
</script>

